unit IWInitApache;

// Dont package, these units link to "Application" units in Delphi and we dont want to
// link the user to more than is necessary.
{$DENYPACKAGEUNIT ON}

interface

uses
  IWInit, // MUST explicitly link this in
  ApacheApp, // Necessary to force inclusion.
  IWAppForm, IWServerControllerBase;

{$IFDEF Linux}
(*$HPPEMIT '#pragma link "IWInitApache.o"'*)
(*$HPPEMIT '#pragma link "ApacheApp.o"'*)
(*$HPPEMIT '#pragma link "WebBroker.o"'*)
{$ELSE}
(*$HPPEMIT '#pragma link "IWInitApache.obj"'*)
(*$HPPEMIT '#pragma link "ApacheApp.obj"'*)
(*$HPPEMIT '#pragma link "webbroker.obj"'*)
(*$HPPEMIT '#pragma link "ReqMulti.obj"'*)
(*$HPPEMIT '#pragma link "WebSnap.lib"'*)
(*$HPPEMIT '#pragma link "WebDSnap.lib"'*)
{$ENDIF}

// Procs
  procedure IWRun;

implementation

uses
  IWGlobal, IWServer, IWResourceStrings,
  SWService, SysUtils, SWSystem,
  WebBroker;

procedure IWRun;
begin
  try
    {$IFNDEF Linux}
    if not IsLibrary then begin
      raise Exception.Create(RSApacheDSOError);
    end;
    {$ENDIF}
    GAppModeInit(WebBroker.Application);
    WebBroker.Application.Initialize;
    WebBroker.Application.CreateForm(TIWServer, GIWServer);
    WebBroker.Application.Run;
  except
    on E: Exception do begin
      FileAppend(ChangeFileExt(GAppPathname, '.err'), RSTextError + E.Message + EOL);
    end;
  end;
end;

initialization
  GAppType := atApache;
end.
