unit IWInitApacheTwo;

// Dont package, these units link to "Application" units in Delphi and we dont want to
// link the user to more than is necessary.
{$DENYPACKAGEUNIT ON}

interface

uses
  ApacheTwoApp, // Necessary to force inclusion.
  IWAppForm, IWServerControllerBase;

// Procs
  procedure IWRun;

implementation

uses
  IWInit, IWGlobal, IWServer, IWResourceStrings,
  SWService, SysUtils, SWSystem,
  WebBroker;

(*$HPPEMIT '#pragma link "IWInitApacheTwo.obj"'*)
(*$HPPEMIT '#pragma link "ApacheAppTwo.obj"'*)
(*$HPPEMIT '#pragma link "webbroker.obj"'*)
(*$HPPEMIT '#pragma link "ReqMulti.obj"'*)
(*$HPPEMIT '#pragma link "WebSnap.lib"'*)
(*$HPPEMIT '#pragma link "WebDSnap.lib"'*)

procedure IWRun;
begin
  try
    {$IFNDEF Linux}
    if not IsLibrary then begin
      raise Exception.Create(RSApacheDSOError);
    end;
    {$ENDIF}
    GAppModeInit(WebBroker.Application);
    WebBroker.Application.Initialize;
    WebBroker.Application.CreateForm(TIWServer, GIWServer);
    WebBroker.Application.Run;
  except
    on E: Exception do begin
      FileAppend(ChangeFileExt(ParamStr(0), '.err'), 'Error: ' + E.Message + EOL);
    end;
  end;
end;

initialization
  GAppType := atApache;
end.
